const Mesa = require('vendor/Mesa.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {

  /**
   * Mesa Script
   *
   * @param {object} payload The payload data
   * @param {object} context Additional context about this task
   */
  script = (payload, context) => {
    const vars = context.steps;

    // Assuming product.published_at is in "YYYY-MM-DD" format
    const publishedAt = vars.shopify.published_at; // Replace this with product.published_at

    // Parse the published_at date
    const publishedAtDate = new Date(publishedAt);

    // Get today's date (with time set to 00:00:00 for accurate day difference calculation)
    const today = new Date();
    today.setHours(0, 0, 0, 0);

    // Calculate the difference in milliseconds
    const differenceInMilliseconds = today - publishedAtDate;

    // Convert milliseconds to days
    const differenceInDays = differenceInMilliseconds / (1000 * 60 * 60 * 24);

    // Subtract the difference from 90
    const daysRemaining = Math.round(90 - differenceInDays);

    Mesa.trigger.setTaskExternalData({
      "label": daysRemaining + " days remaining"
    })

    Mesa.output.next({"days": daysRemaining);
  }
}
